| Version: 3.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
wxModalDialogHook Class Referenceabstract

`#include <wx/modalhook.h>`

Inheritance diagram for wxModalDialogHook:
[legend]

## Detailed Description

Allows intercepting all modal dialog calls.

This class can be used to hook into normal modal dialog handling for some special needs. One of the most common use cases is for testing: as automatic tests can't continue if a modal dialog is shown while they run, this class can be used to avoid showing the modal dialogs during unattended execution. wxModalDialogHook can also be used for disabling some background operation while a modal dialog is shown.

To install a modal dialog hook, you need to derive your own class from this one and implement its pure virtual Enter() method. Then simply create an object of your class and call Register() on it to start receiving calls to your overridden Enter() (and possibly Exit()) methods:

class MyModalDialogHook : public wxModalDialogHook
{
protected:
virtual int Enter(wxDialog* dialog)
{
// Just for demonstration purposes, intercept all uses of
// wxFileDialog. Notice that this doesn't provide any real
// sandboxing, of course, the program can still read and write
// files by not using wxFileDialog to ask the user for their
// names.
if ( wxDynamicCast(dialog, wxFileDialog) )
{
wxLogError("Access to file system disallowed.");
// Skip showing the file dialog entirely.
return wxID_CANCEL;
}
m_lastEnter = wxDateTime::Now();
// Allow the dialog to be shown as usual.
return wxID_NONE;
}
virtual void Exit(wxDialog* dialog)
{
// Again, just for demonstration purposes, show how long did
// the user take to dismiss the dialog. Notice that we
// shouldn't use wxLogMessage() here as this would result in
// another modal dialog call and hence infinite recursion. In
// general, the hooks should be as unintrusive as possible.
wxLogDebug("%s dialog took %s to be dismissed",
dialog->GetClassInfo()->GetClassName(),
(wxDateTime::Now() - m_lastEnter).Format());
}
};
class MyApp : public wxApp
{
public:
virtual bool OnInit()
{
...
m_myHook.Register();
...
}
private:
MyModalDialogHook m_myHook;
};
wxApp
The wxApp class represents the application itself when wxUSE_GUI=1.
Definition: app.h:979
wxClassInfo::GetClassName
const wxChar * GetClassName() const
Returns the string form of the class name.
wxDateTime::Now
static wxDateTime Now()
Returns the object corresponding to the current time in local time zone.
wxDialog
A dialog box is a window with a title bar and sometimes a system menu, which can be moved around the ...
Definition: dialog.h:159
wxFileDialog
This class represents the file chooser dialog.
Definition: filedlg.h:200
wxModalDialogHook
Allows intercepting all modal dialog calls.
Definition: modalhook.h:79
wxModalDialogHook::Exit
virtual void Exit(wxDialog *dialog)
Called by wxWidgets after dismissing the modal dialog.
wxModalDialogHook::Enter
virtual int Enter(wxDialog *dialog)=0
Called by wxWidgets before showing any modal dialogs.
wxObject::GetClassInfo
virtual wxClassInfo * GetClassInfo() const
This virtual function is redefined for every class that requires run-time type information,...
wxID_CANCEL
@ wxID_CANCEL
Definition: defs.h:660
wxID_NONE
@ wxID_NONE
No id matches this one when compared to it.
Definition: defs.h:580
wxLogError
void wxLogError(const char *formatString,...)
The functions to use for error messages, i.e.
wxLogDebug
void wxLogDebug(const char *formatString,...)
The function to use for debugging output.
wxDynamicCast
#define wxDynamicCast(ptr, classname)
This macro returns the pointer ptr cast to the type classname * if the pointer is of this type (the c...
Definition: object.h:865

Since
  2.9.5

## Public Member Functions
| wxModalDialogHook ()
| Default and trivial constructor. More...
virtual | ~wxModalDialogHook ()
| Destructor unregisters the hook if it's currently active. More...
void | Register ()
| Register this hook as being active. More...
void | Unregister ()
| Unregister this hook. More...

## Static Public Member Functions
static int | GetOpenCount ()
| Return the number of currently open modal dialogs. More...

## Protected Member Functions
virtual int | Enter (wxDialog *dialog)=0
| Called by wxWidgets before showing any modal dialogs. More...
virtual void | Exit (wxDialog *dialog)
| Called by wxWidgets after dismissing the modal dialog. More...

## Constructor & Destructor Documentation

## ◆ wxModalDialogHook()

wxModalDialogHook::wxModalDialogHook | ( |  | ) |

Default and trivial constructor.

The constructor doesn't do anything, call Register() to make this hook active.

## ◆ ~wxModalDialogHook()

virtual wxModalDialogHook::~wxModalDialogHook | ( |  | ) |
| virtual

Destructor unregisters the hook if it's currently active.

## Member Function Documentation

## ◆ Enter()

virtual int wxModalDialogHook::Enter | ( | wxDialog * | dialog | ) |
| protected pure virtual

Called by wxWidgets before showing any modal dialogs.

Override this to be notified whenever a modal dialog is about to be shown.

If the return value of this method is wxID_NONE, the dialog is shown as usual and Exit() will be called when it is dismissed. If the return value is anything else, the dialog is not shown at all and its wxDialog::ShowModal() simply returns with the given result. In this case, Exit() won't be called either.

Parameters

  dialog | The dialog about to be shown, never nullptr.

Returns
  wxID_NONE to continue with showing the dialog or anything else to skip showing the dialog and just return this value from its ShowModal().

## ◆ Exit()

virtual void wxModalDialogHook::Exit | ( | wxDialog * | dialog | ) |
| protected virtual

Called by wxWidgets after dismissing the modal dialog.

Notice that it won't be called if Enter() hadn't been called because another modal hook, registered after this one, intercepted the dialog or if our Enter() was called but returned a value different from wxID_NONE.

Parameters

  dialog | The dialog that was shown and dismissed, never nullptr.

## ◆ GetOpenCount()

static int wxModalDialogHook::GetOpenCount | ( |  | ) |
| static

Return the number of currently open modal dialogs.

Mostly this function is used to check if there are any open modal dialogs by comparing its result with 0.

Since
  3.3.0

## ◆ Register()

void wxModalDialogHook::Register | ( |  | ) |

Register this hook as being active.

After registering the hook, its Enter() and Exit() methods will be called whenever a modal dialog is shown.

Notice that the order of registration matters: the last hook registered is called first, and if its Enter() returns a value different from wxID_NONE, the subsequent hooks are skipped.

It is an error to register the same hook twice.

## ◆ Unregister()

void wxModalDialogHook::Unregister | ( |  | ) |

Unregister this hook.

Notice that is done automatically from the destructor, so usually calling this method explicitly is unnecessary.

The hook must be currently registered.